#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include "bmp.h"

BMPSIZE readbmp(char *filename, unsigned char *data, unsigned char returntype, unsigned long maxsize)
{	BMPSIZE size={0,0};	

	if (filename[0]==0)
	{	size.y=1;
		return size;
	}

	FILE *fp;

	fp=fopen (filename,"rb");
	if (fp==0)
	{	size.y=2;
		return size;
	}

	BMPHEADER bmphdr;

	fread(&bmphdr,1,54,fp);

	if ((bmphdr.ident[0]!='B')||(bmphdr.ident[1]!='M'))
	{	fclose(fp);
		size.y=3;
		return size;
	}

	if ((maxsize)&&(((returntype==BMP_BW)&&((bmphdr.width*bmphdr.height)/8>maxsize))||((returntype==BMP_GRAY)&&((bmphdr.width*bmphdr.height)>maxsize))||((returntype==BMP_RGB)&&((bmphdr.width*bmphdr.height)*3>maxsize))))
	{	fclose(fp);
		size.y=4;
		return size;
	}

	if (bmphdr.compression!=0)
	{	fclose(fp);
		size.y=5;
		return size;
	}

	if (bmphdr.colors==0)
		bmphdr.colors=(1<<bmphdr.bits);

	if ((bmphdr.colors!=2)&&(bmphdr.colors!=256)&&(bmphdr.colors!=16777216))
	{	fclose(fp);
		size.y=6;
		return size;
	}

	size.x=(unsigned short)bmphdr.width;
	size.y=(unsigned short)bmphdr.height;

	unsigned long x,y,rp=0;
	unsigned char w,c,cw,r,g,b;
	unsigned int i, linesize;
	unsigned char lutr[256], lutg[256], lutb[256];
	unsigned char *zp;

	if (returntype==BMP_BW)
	{	linesize=(bmphdr.width+7)/8;
	}
	else if (returntype==BMP_GRAY)
	{	linesize=bmphdr.width;
	}
	else if (returntype==BMP_RGB)
	{	linesize=bmphdr.width*3;
	}
	if (bmphdr.colors<=256)
		for (i=0; i<bmphdr.colors; i++)
		{	lutb[i]=fgetc(fp);
			lutg[i]=fgetc(fp);
			lutr[i]=fgetc(fp);
			fgetc(fp);
		}

	for (y=0; y<bmphdr.height; y++)
	{	zp=&data[(bmphdr.height-1-y)*linesize];
		for (x=0; x<bmphdr.width; x++)
		{	if (bmphdr.colors==2)
			{	if ((x&7)==0)
				{	w=fgetc(fp);
					rp++;
				}
				if(w&128)
					c=255;
				else
					c=0;
				w=w<<1;
				r=g=b=c;
			}	
			else if (bmphdr.colors==256)
			{	c=fgetc(fp);
				b=lutb[c];
				g=lutg[c];
				r=lutr[c];
				c=(int)(0.11*r+0.59*g+0.3*b);
				rp+=3;
			}
			else if (bmphdr.colors==16777216)
			{	b=fgetc(fp);
				g=fgetc(fp);
				r=fgetc(fp);
				c=(int)(0.11*r+0.59*g+0.3*b);
				rp+=3;
			}
			if (returntype==BMP_BW)
			{	cw|=c/128;
				cw=cw<<1;
				if ((x&7)==7)
					*zp++=cw;
			}
			else if (returntype==BMP_GRAY)
			{	*zp++=c;
			}
			else if (returntype==BMP_RGB)
			{	*zp++=r;
				*zp++=g;
				*zp++=b;
			}
		}
		while (rp&3)
		{	fgetc(fp);
			rp++;
		}

	}

	fclose(fp);
	return size;
}

int writebmp(char *filename, unsigned char *data, unsigned short width, unsigned short height, unsigned char datatype, unsigned char filetype)
{
	if (filename[0]==0)
	{	return 1;
	}

	FILE *fp;

	fp=fopen (filename,"wb");
	if (fp==0)
	{	return 2;
	}

	BMPHEADER bmphdr;

	if (filetype==BMP_BW)
	{	bmphdr.bmpdata=((((width+7)/8)+3)/4)*4*height;
		bmphdr.bits=1;
	}
	else if (filetype==BMP_RGB)
	{	bmphdr.bmpdata=(((width*3)+3)/4)*4*height;
		bmphdr.bits=24;
	}
	
	bmphdr.filesize=bmphdr.bmpdata+54;
	bmphdr.compression=0;
	bmphdr.dataoffset=54;
	bmphdr.hresolution=150;
	bmphdr.vresolution=150;
	bmphdr.height=height;
	bmphdr.width=width;
	bmphdr.ident[0]='B';
	bmphdr.ident[1]='M';
	bmphdr.impcolors=0;
	bmphdr.colors=1<<bmphdr.bits;
	bmphdr.headersize=54;

	fwrite(&bmphdr,1,54,fp);

	unsigned long x,y,rp;
	unsigned char w,c,cw,r,g,b;
	unsigned int linesize;
	unsigned char *zp;

	if (datatype==BMP_BW)
	{	linesize=(bmphdr.width+7)/8;
	}
	else if (datatype==BMP_GRAY)
	{	linesize=bmphdr.width;
	}
	else if (datatype==BMP_RGB)
	{	linesize=bmphdr.width*3;
	}

	for (y=0; y<bmphdr.height; y++)
	{	zp=&data[(bmphdr.height-1-y)*linesize];
		rp=0;
		for (x=0; x<bmphdr.width; x++)
		{	if (datatype==BMP_BW)
			{	if ((x&7)==0)
				{	w=*zp++;
				}
				if (w&128)
					c=255;
				else
					c=0;
				w=w<<1;
				r=g=b=c;
			}
			else if (datatype==BMP_GRAY)
			{	c=*zp++;
				r=g=b=c;
			}
			else if (datatype==BMP_RGB)
			{	b=*zp++;
				g=*zp++;
				r=*zp++;
				c=(int)(0.11*r+0.59*g+0.3*b);
			}
			if (filetype==BMP_BW)
			{	cw=cw<<1;
				cw|=c/128;
				if ((x&7)==7)
				{	fputc(cw,fp);
					rp++;
				}
			}
			else if (filetype==BMP_RGB)
			{	fputc(b,fp);
				fputc(g,fp);
				fputc(r,fp);
				rp+=3;
			}
		}
		while (rp&3)
		{	fputc(0,fp);
			rp++;
		}
	}
	fclose(fp);
	return 0;
}