#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include "bmp.h"

unsigned char bmpin[2048*2048*8];
unsigned char bmp3dc[2048*2048*4];
unsigned char bmpout[2048*2048*8];

unsigned short rp;
unsigned char bbuf;

#define BLOCKSIZE	4
#define BPP			1

//#define FILEIN "E:\\tftpix\\1024x768\\RGB\\amp.bmp"
//#define FILEIN "E:\\tftpix\\640x480\\RGB\\hotel.bmp"
//#define FILEIN "E:\\dive.bmp"
#define FILEIN "E:\\testin.bmp"

//#define RGB_INDI	// RGB getrennt betrachten

void writebits(unsigned char *comdata, unsigned char data)
{	unsigned char i;
	for (i=0; i<BPP; i++)
	{	bbuf<<=1;
		if (data&(1<<(BPP-1)))
			bbuf|=1;
		data<<=1;
		if ((rp&7)==7)
			comdata[rp/8]=bbuf;
		rp++;
	}
}

void writebitsclose(unsigned char *comdata)
{	
	if (!(rp&7))		// nothing to do
		return;
	printf("Closing Array ");
	while (rp&7)
	{	bbuf<<=1;
		if ((rp&7)==7)
			comdata[rp/8]=bbuf;
		rp++;
	}
}

unsigned char getbits(unsigned char *comdata)
{	unsigned char i, data=0;
	for (i=0; i<BPP; i++)
	{	if ((rp&7)==0)
			bbuf=comdata[rp/8];
		data<<=1;
		if (bbuf&128)
			data|=1;
		bbuf<<=1;
		rp++;
	}
	return data;
}

void rgb_to_3dc(unsigned char rgbdata[BLOCKSIZE][BLOCKSIZE][3], unsigned char *comdata)
{	unsigned char rgbtab[1<<BPP][3], min[3]={255,255,255},max[3]={0,0,0};
	int i,j,x,y,tab;
	for (y=0; y<BLOCKSIZE; y++)					// Find Min/max
	{	for (x=0; x<BLOCKSIZE; x++)
		{	for (i=0; i<3; i++)
			{	if (rgbdata[y][x][i]>max[i])
					max[i]=rgbdata[y][x][i];
				else if (rgbdata[y][x][i]<min[i])
					min[i]=rgbdata[y][x][i];
			}
		}
	}
	for (i=0; i<3; i++)					// Generate LUT
	{	rgbtab[0][i]=min[i];
		rgbtab[(1<<BPP)-1][i]=max[i];
	}
	for (i=1; i<((1<<BPP)-1); i++)
	{	rgbtab[i][0]=((rgbtab[(1<<BPP)-1][0]*i)+(rgbtab[0][0]*((1<<BPP)-1-i)))/((1<<BPP)-1);
		rgbtab[i][1]=((rgbtab[(1<<BPP)-1][1]*i)+(rgbtab[0][1]*((1<<BPP)-1-i)))/((1<<BPP)-1);
		rgbtab[i][2]=((rgbtab[(1<<BPP)-1][2]*i)+(rgbtab[0][2]*((1<<BPP)-1-i)))/((1<<BPP)-1);
	}
	*comdata++=rgbtab[0][0];
	*comdata++=rgbtab[0][1];
	*comdata++=rgbtab[0][2];
	*comdata++=rgbtab[(1<<BPP)-1][0];
	*comdata++=rgbtab[(1<<BPP)-1][1];
	*comdata++=rgbtab[(1<<BPP)-1][2];

	rp=0;
	for (y=0; y<BLOCKSIZE; y++)					// search nearest colors
	{	for (x=0; x<BLOCKSIZE; x++)
		{
#ifdef RGB_INDI
			for (i=0; i<3; i++)
			{	tab=0;
				for (j=1; j<(1<<BPP); j++)
				{	if (abs(rgbdata[y][x][i]-rgbtab[j][i])<abs(rgbdata[y][x][i]-rgbtab[tab][i]))	// Momentaner wert passe passer als bisheriger ?
						tab=j;
				}
				writebits(comdata,tab);
			}
#else
			tab=0;
			for (j=1; j<(1<<BPP); j++)
			{	if ((abs(rgbdata[y][x][0]-rgbtab[j][0])+abs(rgbdata[y][x][1]-rgbtab[j][1])+abs(rgbdata[y][x][2]-rgbtab[j][2]))<(abs(rgbdata[y][x][0]-rgbtab[tab][0])+abs(rgbdata[y][x][1]-rgbtab[tab][1])+abs(rgbdata[y][x][2]-rgbtab[tab][2])))	// Momentaner wert passe passer als bisheriger ?
					tab=j;
			}
			writebits(comdata,tab);
#endif
		}
	}
	writebitsclose(comdata);
}

void dc_to_rgb(unsigned char *comdata, unsigned char rgbdata[BLOCKSIZE][BLOCKSIZE][3])
{	unsigned char rgbtab[1<<BPP][3], i,x,y,tab;
	rgbtab[0][0]=*comdata++;
	rgbtab[0][1]=*comdata++;
	rgbtab[0][2]=*comdata++;
	rgbtab[(1<<BPP)-1][0]=*comdata++;
	rgbtab[(1<<BPP)-1][1]=*comdata++;
	rgbtab[(1<<BPP)-1][2]=*comdata++;
	for (i=1; i<((1<<BPP)-1); i++)
	{	rgbtab[i][0]=((rgbtab[(1<<BPP)-1][0]*i)+(rgbtab[0][0]*((1<<BPP)-1-i)))/((1<<BPP)-1);
		rgbtab[i][1]=((rgbtab[(1<<BPP)-1][1]*i)+(rgbtab[0][1]*((1<<BPP)-1-i)))/((1<<BPP)-1);
		rgbtab[i][2]=((rgbtab[(1<<BPP)-1][2]*i)+(rgbtab[0][2]*((1<<BPP)-1-i)))/((1<<BPP)-1);
	}
	rp=0;
	for (y=0; y<BLOCKSIZE; y++)
	{	for (x=0; x<BLOCKSIZE; x++)
		{	tab=getbits(comdata);
			rgbdata[y][x][0]=rgbtab[tab][0];
#ifdef RGB_INDI
			tab=getbits(comdata);
#endif
			rgbdata[y][x][1]=rgbtab[tab][1];
#ifdef RGB_INDI
			tab=getbits(comdata);
#endif
			rgbdata[y][x][2]=rgbtab[tab][2];
		}
	}
}

int main(void)
{
	unsigned char buffrgb[BLOCKSIZE][BLOCKSIZE][3], cdata[256];

	BMPSIZE size;
	int c,i,x,y,xi,yi,fs;
/*
	rp=0;
	for (i=0; i<50; i++)
		writebits(cdata,i);

//	printf("0x%02X 0x%02X ",cdata[0],cdata[1]);

	rp=0;
	for (i=0; i<50; i++)
	{	c=getbits(cdata);
		printf("%d ",c);
	}
	return 1;
*/

	size=readbmp(FILEIN,bmpin,BMP_RGB,sizeof(bmpin));
	if (size.x==0)
	{	printf("Fehler: %d\n",size.y);
		return 0;
	}
	printf ("Bild: X: %d, Y: %d\n",size.x,size.y);

	rp=0;
	fs=0;
	for (y=0; y<((size.y+BLOCKSIZE-1)&(65536-BLOCKSIZE)); y+=BLOCKSIZE)
	{	for (x=0; x<((size.x+BLOCKSIZE-1)&(65536-BLOCKSIZE)); x+=BLOCKSIZE)
		{	for (yi=0; yi<BLOCKSIZE; yi++)
			{	for (xi=0; xi<BLOCKSIZE; xi++)
				{	buffrgb[yi][xi][2]=bmpin[((y+yi)*size.x+x+xi)*3+0];
					buffrgb[yi][xi][1]=bmpin[((y+yi)*size.x+x+xi)*3+1];
					buffrgb[yi][xi][0]=bmpin[((y+yi)*size.x+x+xi)*3+2];
				}
			}
			rgb_to_3dc(buffrgb,cdata);
#ifdef RGB_INDI
			for (i=0; i<(6+(BLOCKSIZE*BLOCKSIZE*3*BPP+7)/8); i++)
#else
			for (i=0; i<(6+(BLOCKSIZE*BLOCKSIZE*BPP+7)/8); i++)
#endif
			{	bmp3dc[fs+i]=cdata[i];
			}
			fs+=i;
		}
	}
	printf("Compression done\n");

	FILE *fp;
	fp=fopen("E:\\pic.3dc","wb");
	fwrite(bmp3dc,1,fs,fp);
	fclose(fp);

	fs=0;
	for (y=0; y<((size.y+BLOCKSIZE-1)&(65536-BLOCKSIZE)); y+=BLOCKSIZE)
	{	for (x=0; x<((size.x+BLOCKSIZE-1)&(65536-BLOCKSIZE)); x+=BLOCKSIZE)
		{
#ifdef RGB_INDI
			for (i=0; i<(6+(BLOCKSIZE*BLOCKSIZE*3*BPP+7)/8); i++)
#else
			for (i=0; i<(6+(BLOCKSIZE*BLOCKSIZE*BPP+7)/8); i++)
#endif
			{	cdata[i]=bmp3dc[fs+i];
			}
			fs+=i;	
			dc_to_rgb(cdata,buffrgb);
			for (yi=0; yi<BLOCKSIZE; yi++)
			{	for (xi=0; xi<BLOCKSIZE; xi++)
				{	bmpout[((y+yi)*size.x+x+xi)*3+0]=buffrgb[yi][xi][0];
					bmpout[((y+yi)*size.x+x+xi)*3+1]=buffrgb[yi][xi][1];
					bmpout[((y+yi)*size.x+x+xi)*3+2]=buffrgb[yi][xi][2];
				}
			}
		}
	}
	printf("Decompression done\n");

	c=writebmp("E:\\bmpout.bmp",bmpout,size.x, size.y,BMP_RGB,BMP_RGB);
	if (c)
	{	printf("Fehler: %d\n",c);
		return 0;
	}

	return 0;
}